/* collection of junk waiting time to sort out
   Copyright (C) 2000 Free Software Foundation, Inc.
   Contributed by Cygnus Solutions.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#ifndef CALMRISC16_SIM_H
#define CALMRISC16_SIM_H

/* gdb register numbers.  */
#define GR_REGNUM_LO	 0
#define GR_REGNUM_HI	15
#define ER_REGNUM_LO	16
#define ER_REGNUM_HI	23
#define AR_REGNUM_LO	24
#define AR_REGNUM_HI	31

/* Register numbers by index.  */
#define GR_REGNUM(grnum) (GR_REGNUM_LO + (grnum))
#define ER_REGNUM(ernum) (ER_REGNUM_LO + (ernum) - 8)
#define AR_REGNUM(arnum) (AR_REGNUM_LO + (arnum) - 8)

/* Specific register numbers.  */
#define LR_REGNUM       (AR_REGNUM (14)) /* LR is a14 */
#define SP_REGNUM       (AR_REGNUM (15)) /* SP is a15 */
#define PC_REGNUM	32
#define SPC_FIQ_REGNUM	33
#define SPC_IRQ_REGNUM	34
#define SR_REGNUM	35
#define SSR_FIQ_REGNUM	36
#define SSR_IRQ_REGNUM	37
#define SSR_SWI_REGNUM	38

/* CGEN operand get/set handlers.  */
/* declare prototypes here */

#define GETTWI GETTSI
#define SETTWI SETTSI

/* Hardware/device support.
   ??? Will eventually want to move device stuff to config files.  */

/* Special purpose traps
   Traps 0 and 1 can't be used by the user, so use them for syscalls and
   breakpoints.  */
#define TRAP_SYSCALL	0
#define TRAP_BREAKPOINT	1

PCADDR calmrisc16_setup_trq (SIM_CPU *, PCADDR);

/* get/set handlers.  */
HI calmrisc16bf_h_sr_get_handler (SIM_CPU *);

void calmrisc16bf_h_sr_set_handler (SIM_CPU *, HI);

/* Semantic helper functions.  */
void calmrisc16bf_push_gr (SIM_CPU *, IADDR, SI);
void calmrisc16bf_push_ar (SIM_CPU *, IADDR, SI);
void calmrisc16bf_pop_gr (SIM_CPU *, IADDR, SI);
void calmrisc16bf_pop_ar (SIM_CPU *, IADDR, SI);
USI  calmrisc16_swi (SIM_CPU *, PCADDR, int);
void calmrisc16_break (SIM_CPU *);

/* Memory mapping functions.  */
USI calmrisc16bf_program_address (USI);
USI calmrisc16bf_data_address (USI);

/* sim_core_attach device argument.  */
extern device calmrisc16_devices;

/* FIXME: Temporary, until device support ready.  */
struct _device { int foo; };

#endif /* CALMRISC16_SIM_H */
