/* CPU family header for calmrisc16bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999, 2000 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#ifndef CPU_CALMRISC16BF_H
#define CPU_CALMRISC16BF_H

/* Maximum number of instructions that are fetched at a time.
   This is for LIW type instructions sets (e.g. m32r).  */
#define MAX_LIW_INSNS 1

/* Maximum number of instructions that can be executed in parallel.  */
#define MAX_PARALLEL_INSNS 1

/* CPU state information.  */
typedef struct {
  /* Hardware elements.  */
  struct {
  /* program counter */
  USI h_pc;
#define GET_H_PC() CPU (h_pc)
#define SET_H_PC(x) (CPU (h_pc) = (x))
  /* general registers */
  HI h_gr[16];
#define GET_H_GR(a1) CPU (h_gr)[a1]
#define SET_H_GR(a1, x) (CPU (h_gr)[a1] = (x))
  /* Extension registers */
  HI h_er[16];
#define GET_H_ER(a1) CPU (h_er)[a1]
#define SET_H_ER(index, x) \
do { \
CPU (h_er[(index)]) = ANDHI ((x), 63);\
;} while (0)
  /* special registers */
  UHI h_spr[16];
#define GET_H_SPR(a1) CPU (h_spr)[a1]
#define SET_H_SPR(a1, x) (CPU (h_spr)[a1] = (x))
  /* true            bit */
  BI h_t;
#define GET_H_T() CPU (h_t)
#define SET_H_T(x) (CPU (h_t) = (x))
  /* zero            bit */
  BI h_z1;
#define GET_H_Z1() CPU (h_z1)
#define SET_H_Z1(x) (CPU (h_z1) = (x))
  /* zero            bit */
  BI h_z0;
#define GET_H_Z0() CPU (h_z0)
#define SET_H_Z0(x) (CPU (h_z0) = (x))
  /* overflow        bit */
  BI h_v;
#define GET_H_V() CPU (h_v)
#define SET_H_V(x) (CPU (h_v) = (x))
  /* Privileged mode bit */
  BI h_pm;
#define GET_H_PM() CPU (h_pm)
#define SET_H_PM(x) \
do { \
if (CPU (h_pm)) {\
CPU (h_pm) = (x);\
}\
;} while (0)
  /* Trace Enable bit */
  BI h_te;
#define GET_H_TE() CPU (h_te)
#define SET_H_TE(x) \
do { \
if (CPU (h_pm)) {\
CPU (h_te) = (x);\
}\
;} while (0)
  /* IRQ Enable bit */
  BI h_ie;
#define GET_H_IE() CPU (h_ie)
#define SET_H_IE(x) \
do { \
if (CPU (h_pm)) {\
CPU (h_ie) = (x);\
}\
;} while (0)
  /* FIQ Enable bit */
  BI h_fe;
#define GET_H_FE() CPU (h_fe)
#define SET_H_FE(x) \
do { \
if (CPU (h_pm)) {\
CPU (h_fe) = (x);\
}\
;} while (0)
  } hardware;
#define CPU_CGEN_HW(cpu) (& (cpu)->cpu_data.hardware)
} CALMRISC16BF_CPU_DATA;

/* Virtual regs.  */

#define GET_H_R0() CPU (h_gr[((UINT) 0)])
#define SET_H_R0(x) \
do { \
CPU (h_gr[((UINT) 0)]) = (x);\
;} while (0)
#define GET_H_R1() CPU (h_gr[((UINT) 1)])
#define SET_H_R1(x) \
do { \
CPU (h_gr[((UINT) 1)]) = (x);\
;} while (0)
#define GET_H_AR(index) ORSI (SLLSI (CPU (h_er[index]), 16), ANDSI (CPU (h_gr[index]), 65535))
#define SET_H_AR(index, x) \
do { \
{\
SET_H_ER ((index), SRLSI ((x), 16));\
CPU (h_gr[(index)]) = (x);\
}\
;} while (0)
#define GET_H_A8() GET_H_AR (((UINT) 8))
#define SET_H_A8(x) \
do { \
SET_H_AR (((UINT) 8), (x));\
;} while (0)
#define GET_H_A14() GET_H_AR (((UINT) 14))
#define SET_H_A14(x) \
do { \
SET_H_AR (((UINT) 14), (x));\
;} while (0)
#define GET_H_A15() GET_H_AR (((UINT) 15))
#define SET_H_A15(x) \
do { \
SET_H_AR (((UINT) 15), (x));\
;} while (0)
#define GET_H_SPCL_FIQ() CPU (h_spr[((UINT) 0)])
#define SET_H_SPCL_FIQ(x) \
do { \
CPU (h_spr[((UINT) 0)]) = (x);\
;} while (0)
#define GET_H_SPCH_FIQ() CPU (h_spr[((UINT) 1)])
#define SET_H_SPCH_FIQ(x) \
do { \
CPU (h_spr[((UINT) 1)]) = (x);\
;} while (0)
#define GET_H_SSR_FIQ() CPU (h_spr[((UINT) 2)])
#define SET_H_SSR_FIQ(x) \
do { \
CPU (h_spr[((UINT) 2)]) = (x);\
;} while (0)
#define GET_H_SPCL_IRQ() CPU (h_spr[((UINT) 4)])
#define SET_H_SPCL_IRQ(x) \
do { \
CPU (h_spr[((UINT) 4)]) = (x);\
;} while (0)
#define GET_H_SPCH_IRQ() CPU (h_spr[((UINT) 5)])
#define SET_H_SPCH_IRQ(x) \
do { \
CPU (h_spr[((UINT) 5)]) = (x);\
;} while (0)
#define GET_H_SSR_IRQ() CPU (h_spr[((UINT) 6)])
#define SET_H_SSR_IRQ(x) \
do { \
CPU (h_spr[((UINT) 6)]) = (x);\
;} while (0)
#define GET_H_SSR_SWI() CPU (h_spr[((UINT) 10)])
#define SET_H_SSR_SWI(x) \
do { \
CPU (h_spr[((UINT) 10)]) = (x);\
;} while (0)
#define GET_H_SR() calmrisc16bf_h_sr_get_handler (current_cpu)
#define SET_H_SR(x) \
do { \
calmrisc16bf_h_sr_set_handler (current_cpu, (x));\
;} while (0)
#define GET_H_EC2() 0
#define SET_H_EC2(x) \
do { \
((void) 0); /*nop*/\
;} while (0)

/* Cover fns for register access.  */
USI calmrisc16bf_h_pc_get (SIM_CPU *);
void calmrisc16bf_h_pc_set (SIM_CPU *, USI);
HI calmrisc16bf_h_gr_get (SIM_CPU *, UINT);
void calmrisc16bf_h_gr_set (SIM_CPU *, UINT, HI);
HI calmrisc16bf_h_r0_get (SIM_CPU *);
void calmrisc16bf_h_r0_set (SIM_CPU *, HI);
HI calmrisc16bf_h_r1_get (SIM_CPU *);
void calmrisc16bf_h_r1_set (SIM_CPU *, HI);
HI calmrisc16bf_h_er_get (SIM_CPU *, UINT);
void calmrisc16bf_h_er_set (SIM_CPU *, UINT, HI);
USI calmrisc16bf_h_ar_get (SIM_CPU *, UINT);
void calmrisc16bf_h_ar_set (SIM_CPU *, UINT, USI);
USI calmrisc16bf_h_a8_get (SIM_CPU *);
void calmrisc16bf_h_a8_set (SIM_CPU *, USI);
USI calmrisc16bf_h_a14_get (SIM_CPU *);
void calmrisc16bf_h_a14_set (SIM_CPU *, USI);
USI calmrisc16bf_h_a15_get (SIM_CPU *);
void calmrisc16bf_h_a15_set (SIM_CPU *, USI);
UHI calmrisc16bf_h_spr_get (SIM_CPU *, UINT);
void calmrisc16bf_h_spr_set (SIM_CPU *, UINT, UHI);
UHI calmrisc16bf_h_spcl_fiq_get (SIM_CPU *);
void calmrisc16bf_h_spcl_fiq_set (SIM_CPU *, UHI);
UHI calmrisc16bf_h_spch_fiq_get (SIM_CPU *);
void calmrisc16bf_h_spch_fiq_set (SIM_CPU *, UHI);
UHI calmrisc16bf_h_ssr_fiq_get (SIM_CPU *);
void calmrisc16bf_h_ssr_fiq_set (SIM_CPU *, UHI);
UHI calmrisc16bf_h_spcl_irq_get (SIM_CPU *);
void calmrisc16bf_h_spcl_irq_set (SIM_CPU *, UHI);
UHI calmrisc16bf_h_spch_irq_get (SIM_CPU *);
void calmrisc16bf_h_spch_irq_set (SIM_CPU *, UHI);
UHI calmrisc16bf_h_ssr_irq_get (SIM_CPU *);
void calmrisc16bf_h_ssr_irq_set (SIM_CPU *, UHI);
UHI calmrisc16bf_h_ssr_swi_get (SIM_CPU *);
void calmrisc16bf_h_ssr_swi_set (SIM_CPU *, UHI);
BI calmrisc16bf_h_t_get (SIM_CPU *);
void calmrisc16bf_h_t_set (SIM_CPU *, BI);
BI calmrisc16bf_h_z1_get (SIM_CPU *);
void calmrisc16bf_h_z1_set (SIM_CPU *, BI);
BI calmrisc16bf_h_z0_get (SIM_CPU *);
void calmrisc16bf_h_z0_set (SIM_CPU *, BI);
BI calmrisc16bf_h_v_get (SIM_CPU *);
void calmrisc16bf_h_v_set (SIM_CPU *, BI);
BI calmrisc16bf_h_pm_get (SIM_CPU *);
void calmrisc16bf_h_pm_set (SIM_CPU *, BI);
BI calmrisc16bf_h_te_get (SIM_CPU *);
void calmrisc16bf_h_te_set (SIM_CPU *, BI);
BI calmrisc16bf_h_ie_get (SIM_CPU *);
void calmrisc16bf_h_ie_set (SIM_CPU *, BI);
BI calmrisc16bf_h_fe_get (SIM_CPU *);
void calmrisc16bf_h_fe_set (SIM_CPU *, BI);
HI calmrisc16bf_h_sr_get (SIM_CPU *);
void calmrisc16bf_h_sr_set (SIM_CPU *, HI);
USI calmrisc16bf_h_ec2_get (SIM_CPU *);
void calmrisc16bf_h_ec2_set (SIM_CPU *, USI);

/* These must be hand-written.  */
extern CPUREG_FETCH_FN calmrisc16bf_fetch_register;
extern CPUREG_STORE_FN calmrisc16bf_store_register;

typedef struct {
  int empty;
} MODEL_CALMRISC16_DATA;

/* Instruction argument buffer.  */

union sem_fields {
  struct { /* no operands */
    int empty;
  } fmt_empty;
  struct { /*  */
    IADDR i_elabel13;
  } sfmt_bsrd;
  struct { /*  */
    IADDR i_elabel11;
  } sfmt_bra;
  struct { /*  */
    UINT f_bs3;
  } sfmt_bitr;
  struct { /*  */
    UINT f_Rlist;
  } sfmt_popgr;
  struct { /*  */
    UINT f_disp8;
  } sfmt_ldba8disp8;
  struct { /*  */
    UINT f_imm22;
    USI f_An;
  } sfmt_lda22;
  struct { /*  */
    UINT f_imm16;
    USI f_An1;
  } sfmt_addari16;
  struct { /*  */
    UINT f_imm5;
    USI f_An;
  } sfmt_addari5;
  struct { /*  */
    HI* i_Dn1;
    UINT f_Dn1;
    unsigned char out_Dn1;
  } sfmt_cldr;
  struct { /*  */
    UHI* i_Rs;
    UINT f_Rs;
    unsigned char out_Rs;
  } sfmt_ldsrxr0;
  struct { /*  */
    UHI* i_Rs;
    UINT f_Rs;
    unsigned char in_Rs;
  } sfmt_ldr0srx;
  struct { /*  */
    UINT f_disp16;
    USI f_An;
    USI f_An1;
  } sfmt_ldw_ar_a_disp16;
  struct { /*  */
    USI f_An;
    USI f_An2;
    USI f_edisp5;
  } sfmt_ldaaedisp5;
  struct { /*  */
    HI* i_Dn;
    UINT f_Dn;
    UINT f_imm8;
    unsigned char in_Dn;
  } sfmt_cmpeqgrimm8;
  struct { /*  */
    HI* i_Dn;
    UINT f_Dn;
    UINT f_imm6;
    unsigned char in_Dn;
  } sfmt_cmpgegrimm6;
  struct { /*  */
    HI* i_Ri1;
    UINT f_Rn;
    USI f_edisp9;
    unsigned char in_Ri1;
  } sfmt_stwspedisp9;
  struct { /*  */
    HI* i_Di;
    UINT f_Dn;
    USI f_En;
    unsigned char in_Di;
  } sfmt_ldEnDi;
  struct { /*  */
    HI* i_Rn;
    UINT f_Rn;
    USI f_edisp9;
    unsigned char out_Rn;
  } sfmt_ldwspedisp9;
  struct { /*  */
    HI* i_Ri;
    UINT f_Rn1;
    USI f_An;
    unsigned char in_Ri;
  } sfmt_addargr;
  struct { /*  */
    HI* i_H;
    IADDR i_elabel8;
    USI f_H;
    unsigned char in_H;
    unsigned char out_H;
  } sfmt_bnzd;
  struct { /*  */
    HI* i_Di;
    UINT f_Dn;
    UINT f_disp16;
    USI f_An1;
    unsigned char in_Di;
  } sfmt_stbadisp16;
  struct { /*  */
    HI* i_Di;
    UINT f_Dn;
    UINT f_disp4;
    USI f_An2;
    unsigned char in_Di;
  } sfmt_stbadisp4;
  struct { /*  */
    HI* i_Ri1;
    UINT f_Rn;
    UINT f_disp16;
    USI f_An1;
    unsigned char in_Ri1;
  } sfmt_stwadisp16;
  struct { /*  */
    HI* i_Ri1;
    UINT f_Rn;
    USI f_An2;
    USI f_edisp5;
    unsigned char in_Ri1;
  } sfmt_stwaedisp5;
  struct { /*  */
    HI* i_Rn;
    UINT f_Rn;
    UINT f_imm8;
    unsigned char in_Rn;
    unsigned char out_Rn;
  } sfmt_ldi8;
  struct { /*  */
    HI* i_Dn;
    UINT f_Dn;
    USI f_En;
    unsigned char in_Dn;
    unsigned char out_Dn;
  } sfmt_ldDnEi;
  struct { /*  */
    HI* i_Dn;
    UINT f_Dn;
    UINT f_disp16;
    USI f_An1;
    unsigned char out_Dn;
  } sfmt_ldbadisp16;
  struct { /*  */
    HI* i_Dn;
    UINT f_Dn;
    UINT f_disp4;
    USI f_An2;
    unsigned char out_Dn;
  } sfmt_ldbadisp4;
  struct { /*  */
    HI* i_Rn;
    UINT f_Rn;
    UINT f_disp16;
    USI f_An1;
    unsigned char out_Rn;
  } sfmt_ldw_gr_a_disp16;
  struct { /*  */
    HI* i_Rn;
    UINT f_Rn;
    USI f_An2;
    USI f_edisp5;
    unsigned char out_Rn;
  } sfmt_ldwaedisp5;
  struct { /*  */
    HI* i_Rj;
    UINT f_Rn1;
    USI f_An;
    USI f_An2;
    unsigned char in_Rj;
  } sfmt_ldaaRj;
  struct { /*  */
    HI* i_Rn1;
    UINT f_Rn1;
    UINT f_imm16;
    unsigned char in_Rn1;
    unsigned char out_Rn1;
  } sfmt_addgri16;
  struct { /*  */
    HI* i_Rn;
    UINT f_Rn;
    UINT f_imm7;
    unsigned char in_Rn;
    unsigned char out_Rn;
  } sfmt_addgri7;
  struct { /*  */
    HI* i_Di;
    HI* i_Rm;
    UINT f_Dn;
    UINT f_Rm;
    USI f_An2;
    unsigned char in_Di;
    unsigned char in_Rm;
  } sfmt_stbaRm;
  struct { /*  */
    HI* i_Ri1;
    HI* i_Rj;
    UINT f_Rn;
    UINT f_Rn1;
    USI f_An2;
    unsigned char in_Ri1;
    unsigned char in_Rj;
  } sfmt_stwaRj;
  struct { /*  */
    HI* i_Dn;
    HI* i_Rj;
    UINT f_Dn;
    UINT f_Rn1;
    USI f_An2;
    unsigned char in_Rj;
    unsigned char out_Dn;
  } sfmt_ldbaRj;
  struct { /*  */
    HI* i_Rj;
    HI* i_Rn;
    UINT f_Rn;
    UINT f_Rn1;
    USI f_An2;
    unsigned char in_Rj;
    unsigned char out_Rn;
  } sfmt_ldwaRj;
  struct { /*  */
    HI* i_Di1;
    HI* i_Dn;
    UINT f_Dn;
    UINT f_Dn1;
    unsigned char in_Di1;
    unsigned char in_Dn;
    unsigned char out_Dn;
  } sfmt_muluu;
  struct { /*  */
    HI* i_Ri;
    HI* i_Rn;
    UINT f_Rn;
    UINT f_Rn1;
    unsigned char in_Ri;
    unsigned char in_Rn;
    unsigned char out_Rn;
  } sfmt_addgrgr;
#if WITH_SCACHE_PBB
  /* Writeback handler.  */
  struct {
    /* Pointer to argbuf entry for insn whose results need writing back.  */
    const struct argbuf *abuf;
  } write;
  /* x-before handler */
  struct {
    /*const SCACHE *insns[MAX_PARALLEL_INSNS];*/
    int first_p;
  } before;
  /* x-after handler */
  struct {
    int empty;
  } after;
  /* This entry is used to terminate each pbb.  */
  struct {
    /* Number of insns in pbb.  */
    int insn_count;
    /* Next pbb to execute.  */
    SCACHE *next;
    SCACHE *branch_target;
  } chain;
#endif
};

/* The ARGBUF struct.  */
struct argbuf {
  /* These are the baseclass definitions.  */
  IADDR addr;
  const IDESC *idesc;
  char trace_p;
  char profile_p;
  /* ??? Temporary hack for skip insns.  */
  char skip_count;
  char unused;
  /* cpu specific data follows */
  union sem semantic;
  int written;
  union sem_fields fields;
};

/* A cached insn.

   ??? SCACHE used to contain more than just argbuf.  We could delete the
   type entirely and always just use ARGBUF, but for future concerns and as
   a level of abstraction it is left in.  */

struct scache {
  struct argbuf argbuf;
};

/* Macros to simplify extraction, reading and semantic code.
   These define and assign the local vars that contain the insn's fields.  */

#define EXTRACT_IFMT_EMPTY_VARS \
  unsigned int length;
#define EXTRACT_IFMT_EMPTY_CODE \
  length = 0; \

#define EXTRACT_IFMT_CLRSRFE_VARS \
  UINT f_op1; \
  UINT f_op2; \
  UINT f_op3; \
  UINT f_op12_1; \
  UINT f_bs3; \
  unsigned int length;
#define EXTRACT_IFMT_CLRSRFE_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op2 = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 16, 12, 1); \
  f_bs3 = EXTRACT_MSB0_UINT (insn, 16, 13, 3); \

#define EXTRACT_IFMT_ADDGRGR_VARS \
  UINT f_op1; \
  UINT f_Rn; \
  UINT f_op3; \
  UINT f_Rn1; \
  unsigned int length;
#define EXTRACT_IFMT_ADDGRGR_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_Rn = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_Rn1 = EXTRACT_MSB0_UINT (insn, 16, 12, 4); \

#define EXTRACT_IFMT_MULUU_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  UINT f_Dn; \
  UINT f_op3; \
  UINT f_op12_1; \
  UINT f_Dn1; \
  unsigned int length;
#define EXTRACT_IFMT_MULUU_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 16, 4, 1); \
  f_Dn = EXTRACT_MSB0_UINT (insn, 16, 5, 3); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 16, 12, 1); \
  f_Dn1 = EXTRACT_MSB0_UINT (insn, 16, 13, 3); \

#define EXTRACT_IFMT_ADDGRI7_VARS \
  UINT f_op1; \
  UINT f_Rn; \
  UINT f_op8_1; \
  UINT f_imm7; \
  unsigned int length;
#define EXTRACT_IFMT_ADDGRI7_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_Rn = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op8_1 = EXTRACT_MSB0_UINT (insn, 16, 8, 1); \
  f_imm7 = EXTRACT_MSB0_UINT (insn, 16, 9, 7); \

#define EXTRACT_IFMT_ADDGRI16_VARS \
  UINT f_op1; \
  UINT f_imm16; \
  UINT f_op2; \
  UINT f_op3; \
  UINT f_Rn1; \
  unsigned int length;
#define EXTRACT_IFMT_ADDGRI16_CODE \
  length = 4; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 32, 0, 4); \
  f_imm16 = EXTRACT_MSB0_UINT (insn, 32, 16, 16); \
  f_op2 = EXTRACT_MSB0_UINT (insn, 32, 4, 4); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 32, 8, 4); \
  f_Rn1 = EXTRACT_MSB0_UINT (insn, 32, 12, 4); \

#define EXTRACT_IFMT_ADDARGR_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  USI f_An; \
  UINT f_op3; \
  UINT f_Rn1; \
  unsigned int length;
#define EXTRACT_IFMT_ADDARGR_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 16, 4, 1); \
  f_An = ((EXTRACT_MSB0_UINT (insn, 16, 5, 3)) + (8)); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_Rn1 = EXTRACT_MSB0_UINT (insn, 16, 12, 4); \

#define EXTRACT_IFMT_ADDARI5_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  USI f_An; \
  UINT f_op8_3; \
  UINT f_imm5; \
  unsigned int length;
#define EXTRACT_IFMT_ADDARI5_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 16, 4, 1); \
  f_An = ((EXTRACT_MSB0_UINT (insn, 16, 5, 3)) + (8)); \
  f_op8_3 = EXTRACT_MSB0_UINT (insn, 16, 8, 3); \
  f_imm5 = EXTRACT_MSB0_UINT (insn, 16, 11, 5); \

#define EXTRACT_IFMT_ADDARI16_VARS \
  UINT f_op1; \
  UINT f_imm16; \
  UINT f_op2; \
  UINT f_op3; \
  UINT f_op12_1; \
  USI f_An1; \
  unsigned int length;
#define EXTRACT_IFMT_ADDARI16_CODE \
  length = 4; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 32, 0, 4); \
  f_imm16 = EXTRACT_MSB0_UINT (insn, 32, 16, 16); \
  f_op2 = EXTRACT_MSB0_UINT (insn, 32, 4, 4); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 32, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 32, 12, 1); \
  f_An1 = ((EXTRACT_MSB0_UINT (insn, 32, 13, 3)) + (8)); \

#define EXTRACT_IFMT_COM_VARS \
  UINT f_op1; \
  UINT f_op2; \
  UINT f_op3; \
  UINT f_Rn1; \
  unsigned int length;
#define EXTRACT_IFMT_COM_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op2 = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_Rn1 = EXTRACT_MSB0_UINT (insn, 16, 12, 4); \

#define EXTRACT_IFMT_ANDGRI8_VARS \
  UINT f_op1; \
  UINT f_op2; \
  UINT f_imm8; \
  unsigned int length;
#define EXTRACT_IFMT_ANDGRI8_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op2 = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_imm8 = EXTRACT_MSB0_UINT (insn, 16, 8, 8); \

#define EXTRACT_IFMT_LDWARJ_VARS \
  UINT f_op1; \
  UINT f_Rn; \
  UINT f_op8_1; \
  USI f_An2; \
  UINT f_Rn1; \
  unsigned int length;
#define EXTRACT_IFMT_LDWARJ_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_Rn = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op8_1 = EXTRACT_MSB0_UINT (insn, 16, 8, 1); \
  f_An2 = ((EXTRACT_MSB0_UINT (insn, 16, 9, 3)) + (8)); \
  f_Rn1 = EXTRACT_MSB0_UINT (insn, 16, 12, 4); \

#define EXTRACT_IFMT_LDAARJ_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  USI f_An; \
  UINT f_op8_1; \
  USI f_An2; \
  UINT f_Rn1; \
  unsigned int length;
#define EXTRACT_IFMT_LDAARJ_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 16, 4, 1); \
  f_An = ((EXTRACT_MSB0_UINT (insn, 16, 5, 3)) + (8)); \
  f_op8_1 = EXTRACT_MSB0_UINT (insn, 16, 8, 1); \
  f_An2 = ((EXTRACT_MSB0_UINT (insn, 16, 9, 3)) + (8)); \
  f_Rn1 = EXTRACT_MSB0_UINT (insn, 16, 12, 4); \

#define EXTRACT_IFMT_LDWAEDISP5_VARS \
  UINT f_op1; \
  UINT f_Rn; \
  UINT f_op8_1; \
  USI f_An2; \
  USI f_edisp5; \
  unsigned int length;
#define EXTRACT_IFMT_LDWAEDISP5_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_Rn = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op8_1 = EXTRACT_MSB0_UINT (insn, 16, 8, 1); \
  f_An2 = ((EXTRACT_MSB0_UINT (insn, 16, 9, 3)) + (8)); \
  f_edisp5 = ((EXTRACT_MSB0_UINT (insn, 16, 12, 4)) << (1)); \

#define EXTRACT_IFMT_LDAAEDISP5_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  USI f_An; \
  UINT f_op8_1; \
  USI f_An2; \
  USI f_edisp5; \
  unsigned int length;
#define EXTRACT_IFMT_LDAAEDISP5_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 16, 4, 1); \
  f_An = ((EXTRACT_MSB0_UINT (insn, 16, 5, 3)) + (8)); \
  f_op8_1 = EXTRACT_MSB0_UINT (insn, 16, 8, 1); \
  f_An2 = ((EXTRACT_MSB0_UINT (insn, 16, 9, 3)) + (8)); \
  f_edisp5 = ((EXTRACT_MSB0_UINT (insn, 16, 12, 4)) << (1)); \

#define EXTRACT_IFMT_LDWSPEDISP9_VARS \
  UINT f_op1; \
  UINT f_Rn; \
  USI f_edisp9; \
  unsigned int length;
#define EXTRACT_IFMT_LDWSPEDISP9_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_Rn = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_edisp9 = ((EXTRACT_MSB0_UINT (insn, 16, 8, 8)) << (1)); \

#define EXTRACT_IFMT_LDW_GR_A_DISP16_VARS \
  UINT f_op1; \
  UINT f_disp16; \
  UINT f_Rn; \
  UINT f_op3; \
  UINT f_op12_1; \
  USI f_An1; \
  unsigned int length;
#define EXTRACT_IFMT_LDW_GR_A_DISP16_CODE \
  length = 4; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 32, 0, 4); \
  f_disp16 = EXTRACT_MSB0_UINT (insn, 32, 16, 16); \
  f_Rn = EXTRACT_MSB0_UINT (insn, 32, 4, 4); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 32, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 32, 12, 1); \
  f_An1 = ((EXTRACT_MSB0_UINT (insn, 32, 13, 3)) + (8)); \

#define EXTRACT_IFMT_LDW_AR_A_DISP16_VARS \
  UINT f_op1; \
  UINT f_disp16; \
  UINT f_op4_1; \
  USI f_An; \
  UINT f_op3; \
  UINT f_op12_1; \
  USI f_An1; \
  unsigned int length;
#define EXTRACT_IFMT_LDW_AR_A_DISP16_CODE \
  length = 4; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 32, 0, 4); \
  f_disp16 = EXTRACT_MSB0_UINT (insn, 32, 16, 16); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 32, 4, 1); \
  f_An = ((EXTRACT_MSB0_UINT (insn, 32, 5, 3)) + (8)); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 32, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 32, 12, 1); \
  f_An1 = ((EXTRACT_MSB0_UINT (insn, 32, 13, 3)) + (8)); \

#define EXTRACT_IFMT_LDBARJ_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  UINT f_Dn; \
  UINT f_op8_1; \
  USI f_An2; \
  UINT f_Rn1; \
  unsigned int length;
#define EXTRACT_IFMT_LDBARJ_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 16, 4, 1); \
  f_Dn = EXTRACT_MSB0_UINT (insn, 16, 5, 3); \
  f_op8_1 = EXTRACT_MSB0_UINT (insn, 16, 8, 1); \
  f_An2 = ((EXTRACT_MSB0_UINT (insn, 16, 9, 3)) + (8)); \
  f_Rn1 = EXTRACT_MSB0_UINT (insn, 16, 12, 4); \

#define EXTRACT_IFMT_LDBADISP4_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  UINT f_Dn; \
  UINT f_op8_1; \
  USI f_An2; \
  UINT f_disp4; \
  unsigned int length;
#define EXTRACT_IFMT_LDBADISP4_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 16, 4, 1); \
  f_Dn = EXTRACT_MSB0_UINT (insn, 16, 5, 3); \
  f_op8_1 = EXTRACT_MSB0_UINT (insn, 16, 8, 1); \
  f_An2 = ((EXTRACT_MSB0_UINT (insn, 16, 9, 3)) + (8)); \
  f_disp4 = EXTRACT_MSB0_UINT (insn, 16, 12, 4); \

#define EXTRACT_IFMT_LDBA8DISP8_VARS \
  UINT f_op1; \
  UINT f_op2; \
  UINT f_disp8; \
  unsigned int length;
#define EXTRACT_IFMT_LDBA8DISP8_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op2 = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_disp8 = EXTRACT_MSB0_UINT (insn, 16, 8, 8); \

#define EXTRACT_IFMT_LDBADISP16_VARS \
  UINT f_op1; \
  UINT f_disp16; \
  UINT f_op4_1; \
  UINT f_Dn; \
  UINT f_op3; \
  UINT f_op12_1; \
  USI f_An1; \
  unsigned int length;
#define EXTRACT_IFMT_LDBADISP16_CODE \
  length = 4; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 32, 0, 4); \
  f_disp16 = EXTRACT_MSB0_UINT (insn, 32, 16, 16); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 32, 4, 1); \
  f_Dn = EXTRACT_MSB0_UINT (insn, 32, 5, 3); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 32, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 32, 12, 1); \
  f_An1 = ((EXTRACT_MSB0_UINT (insn, 32, 13, 3)) + (8)); \

#define EXTRACT_IFMT_LDENDI_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  UINT f_Dn; \
  UINT f_op3; \
  UINT f_op12_1; \
  USI f_En; \
  unsigned int length;
#define EXTRACT_IFMT_LDENDI_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 16, 4, 1); \
  f_Dn = EXTRACT_MSB0_UINT (insn, 16, 5, 3); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 16, 12, 1); \
  f_En = ((EXTRACT_MSB0_UINT (insn, 16, 13, 3)) + (8)); \

#define EXTRACT_IFMT_LDDNEI_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  UINT f_Dn; \
  UINT f_op3; \
  UINT f_op12_1; \
  USI f_En; \
  unsigned int length;
#define EXTRACT_IFMT_LDDNEI_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 16, 4, 1); \
  f_Dn = EXTRACT_MSB0_UINT (insn, 16, 5, 3); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 16, 12, 1); \
  f_En = ((EXTRACT_MSB0_UINT (insn, 16, 13, 3)) + (8)); \

#define EXTRACT_IFMT_LDANAI_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  USI f_An; \
  UINT f_op3; \
  UINT f_op12_1; \
  USI f_An1; \
  unsigned int length;
#define EXTRACT_IFMT_LDANAI_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 16, 4, 1); \
  f_An = ((EXTRACT_MSB0_UINT (insn, 16, 5, 3)) + (8)); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 16, 12, 1); \
  f_An1 = ((EXTRACT_MSB0_UINT (insn, 16, 13, 3)) + (8)); \

#define EXTRACT_IFMT_LDANPC_VARS \
  UINT f_op1; \
  UINT f_op2; \
  UINT f_op3; \
  UINT f_op12_1; \
  USI f_An1; \
  unsigned int length;
#define EXTRACT_IFMT_LDANPC_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op2 = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 16, 12, 1); \
  f_An1 = ((EXTRACT_MSB0_UINT (insn, 16, 13, 3)) + (8)); \

#define EXTRACT_IFMT_LDR0SRX_VARS \
  UINT f_op1; \
  UINT f_op2; \
  UINT f_op3; \
  UINT f_Rs; \
  unsigned int length;
#define EXTRACT_IFMT_LDR0SRX_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op2 = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_Rs = EXTRACT_MSB0_UINT (insn, 16, 12, 4); \

#define EXTRACT_IFMT_LDSRR0_VARS \
  UINT f_op1; \
  UINT f_op2; \
  UINT f_op3; \
  UINT f_op4; \
  unsigned int length;
#define EXTRACT_IFMT_LDSRR0_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op2 = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_op4 = EXTRACT_MSB0_UINT (insn, 16, 12, 4); \

#define EXTRACT_IFMT_LDI8_VARS \
  UINT f_op1; \
  UINT f_Rn; \
  UINT f_imm8; \
  unsigned int length;
#define EXTRACT_IFMT_LDI8_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_Rn = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_imm8 = EXTRACT_MSB0_UINT (insn, 16, 8, 8); \

#define EXTRACT_IFMT_LDA22_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  USI f_An; \
  UINT f_op8_2; \
  UINT f_imm22; \
  unsigned int length;
#define EXTRACT_IFMT_LDA22_CODE \
  length = 4; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 32, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 32, 4, 1); \
  f_An = ((EXTRACT_MSB0_UINT (insn, 32, 5, 3)) + (8)); \
  f_op8_2 = EXTRACT_MSB0_UINT (insn, 32, 8, 2); \
  f_imm22 = EXTRACT_MSB0_UINT (insn, 32, 10, 22); \

#define EXTRACT_IFMT_POPGR_VARS \
  UINT f_op1; \
  UINT f_Rlist_Rm; \
  UINT f_Rlist_Rn; \
  UINT f_Rlist; \
  UINT f_op3; \
  UINT f_op12_1; \
  unsigned int length;
#define EXTRACT_IFMT_POPGR_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_Rlist_Rm = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_Rlist_Rn = EXTRACT_MSB0_UINT (insn, 16, 13, 3); \
{\
  f_Rlist = ((((f_Rlist_Rm) << (3))) | (f_Rlist_Rn));\
}\
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 16, 12, 1); \

#define EXTRACT_IFMT_POPAR_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  UINT f_Alist_Am; \
  UINT f_Alist_An; \
  UINT f_Alist; \
  UINT f_op3; \
  UINT f_op12_1; \
  unsigned int length;
#define EXTRACT_IFMT_POPAR_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 16, 4, 1); \
  f_Alist_Am = EXTRACT_MSB0_UINT (insn, 16, 5, 3); \
  f_Alist_An = EXTRACT_MSB0_UINT (insn, 16, 13, 3); \
{\
  f_Alist = ((((f_Alist_Am) << (3))) | (f_Alist_An));\
}\
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 16, 12, 1); \

#define EXTRACT_IFMT_LDC_VARS \
  UINT f_op1; \
  UINT f_Rn; \
  UINT f_op3; \
  UINT f_op12_1; \
  USI f_An1; \
  unsigned int length;
#define EXTRACT_IFMT_LDC_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_Rn = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 16, 12, 1); \
  f_An1 = ((EXTRACT_MSB0_UINT (insn, 16, 13, 3)) + (8)); \

#define EXTRACT_IFMT_STWARJ_VARS \
  UINT f_op1; \
  UINT f_Rn; \
  UINT f_op8_1; \
  USI f_An2; \
  UINT f_Rn1; \
  unsigned int length;
#define EXTRACT_IFMT_STWARJ_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_Rn = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op8_1 = EXTRACT_MSB0_UINT (insn, 16, 8, 1); \
  f_An2 = ((EXTRACT_MSB0_UINT (insn, 16, 9, 3)) + (8)); \
  f_Rn1 = EXTRACT_MSB0_UINT (insn, 16, 12, 4); \

#define EXTRACT_IFMT_STWAEDISP5_VARS \
  UINT f_op1; \
  UINT f_Rn; \
  UINT f_op8_1; \
  USI f_An2; \
  USI f_edisp5; \
  unsigned int length;
#define EXTRACT_IFMT_STWAEDISP5_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_Rn = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op8_1 = EXTRACT_MSB0_UINT (insn, 16, 8, 1); \
  f_An2 = ((EXTRACT_MSB0_UINT (insn, 16, 9, 3)) + (8)); \
  f_edisp5 = ((EXTRACT_MSB0_UINT (insn, 16, 12, 4)) << (1)); \

#define EXTRACT_IFMT_STWSPEDISP9_VARS \
  UINT f_op1; \
  UINT f_Rn; \
  USI f_edisp9; \
  unsigned int length;
#define EXTRACT_IFMT_STWSPEDISP9_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_Rn = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_edisp9 = ((EXTRACT_MSB0_UINT (insn, 16, 8, 8)) << (1)); \

#define EXTRACT_IFMT_STWADISP16_VARS \
  UINT f_op1; \
  UINT f_disp16; \
  UINT f_Rn; \
  UINT f_op3; \
  UINT f_op12_1; \
  USI f_An1; \
  unsigned int length;
#define EXTRACT_IFMT_STWADISP16_CODE \
  length = 4; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 32, 0, 4); \
  f_disp16 = EXTRACT_MSB0_UINT (insn, 32, 16, 16); \
  f_Rn = EXTRACT_MSB0_UINT (insn, 32, 4, 4); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 32, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 32, 12, 1); \
  f_An1 = ((EXTRACT_MSB0_UINT (insn, 32, 13, 3)) + (8)); \

#define EXTRACT_IFMT_STBARM_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  UINT f_Dn; \
  UINT f_op8_1; \
  USI f_An2; \
  UINT f_Rm; \
  unsigned int length;
#define EXTRACT_IFMT_STBARM_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 16, 4, 1); \
  f_Dn = EXTRACT_MSB0_UINT (insn, 16, 5, 3); \
  f_op8_1 = EXTRACT_MSB0_UINT (insn, 16, 8, 1); \
  f_An2 = ((EXTRACT_MSB0_UINT (insn, 16, 9, 3)) + (8)); \
  f_Rm = EXTRACT_MSB0_UINT (insn, 16, 12, 4); \

#define EXTRACT_IFMT_STBADISP4_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  UINT f_Dn; \
  UINT f_op8_1; \
  USI f_An2; \
  UINT f_disp4; \
  unsigned int length;
#define EXTRACT_IFMT_STBADISP4_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 16, 4, 1); \
  f_Dn = EXTRACT_MSB0_UINT (insn, 16, 5, 3); \
  f_op8_1 = EXTRACT_MSB0_UINT (insn, 16, 8, 1); \
  f_An2 = ((EXTRACT_MSB0_UINT (insn, 16, 9, 3)) + (8)); \
  f_disp4 = EXTRACT_MSB0_UINT (insn, 16, 12, 4); \

#define EXTRACT_IFMT_STBADISP16_VARS \
  UINT f_op1; \
  UINT f_disp16; \
  UINT f_op4_1; \
  UINT f_Dn; \
  UINT f_op3; \
  UINT f_op12_1; \
  USI f_An1; \
  unsigned int length;
#define EXTRACT_IFMT_STBADISP16_CODE \
  length = 4; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 32, 0, 4); \
  f_disp16 = EXTRACT_MSB0_UINT (insn, 32, 16, 16); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 32, 4, 1); \
  f_Dn = EXTRACT_MSB0_UINT (insn, 32, 5, 3); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 32, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 32, 12, 1); \
  f_An1 = ((EXTRACT_MSB0_UINT (insn, 32, 13, 3)) + (8)); \

#define EXTRACT_IFMT_BITR_VARS \
  UINT f_op1; \
  UINT f_op2; \
  UINT f_op3; \
  UINT f_op12_1; \
  UINT f_bs3; \
  unsigned int length;
#define EXTRACT_IFMT_BITR_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op2 = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 16, 12, 1); \
  f_bs3 = EXTRACT_MSB0_UINT (insn, 16, 13, 3); \

#define EXTRACT_IFMT_CMPGEGR_VARS \
  UINT f_op1; \
  UINT f_Rn; \
  UINT f_op8_1; \
  UINT f_cmode1; \
  UINT f_Rn1; \
  unsigned int length;
#define EXTRACT_IFMT_CMPGEGR_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_Rn = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op8_1 = EXTRACT_MSB0_UINT (insn, 16, 8, 1); \
  f_cmode1 = EXTRACT_MSB0_UINT (insn, 16, 9, 3); \
  f_Rn1 = EXTRACT_MSB0_UINT (insn, 16, 12, 4); \

#define EXTRACT_IFMT_CMPGEGRIMM6_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  UINT f_Dn; \
  UINT f_op8_2; \
  UINT f_imm6; \
  unsigned int length;
#define EXTRACT_IFMT_CMPGEGRIMM6_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 16, 4, 1); \
  f_Dn = EXTRACT_MSB0_UINT (insn, 16, 5, 3); \
  f_op8_2 = EXTRACT_MSB0_UINT (insn, 16, 8, 2); \
  f_imm6 = EXTRACT_MSB0_UINT (insn, 16, 10, 6); \

#define EXTRACT_IFMT_CMPEQGRIMM8_VARS \
  UINT f_op1; \
  UINT f_op4_1; \
  UINT f_Dn; \
  UINT f_imm8; \
  unsigned int length;
#define EXTRACT_IFMT_CMPEQGRIMM8_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 16, 4, 1); \
  f_Dn = EXTRACT_MSB0_UINT (insn, 16, 5, 3); \
  f_imm8 = EXTRACT_MSB0_UINT (insn, 16, 8, 8); \

#define EXTRACT_IFMT_CMPGEI16_VARS \
  UINT f_op1; \
  UINT f_imm16; \
  UINT f_op4_1; \
  UINT f_cmode2; \
  UINT f_op3; \
  UINT f_Rn1; \
  unsigned int length;
#define EXTRACT_IFMT_CMPGEI16_CODE \
  length = 4; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 32, 0, 4); \
  f_imm16 = EXTRACT_MSB0_UINT (insn, 32, 16, 16); \
  f_op4_1 = EXTRACT_MSB0_UINT (insn, 32, 4, 1); \
  f_cmode2 = EXTRACT_MSB0_UINT (insn, 32, 5, 3); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 32, 8, 4); \
  f_Rn1 = EXTRACT_MSB0_UINT (insn, 32, 12, 4); \

#define EXTRACT_IFMT_BRAEXT_VARS \
  UINT f_op1; \
  UINT f_op4_3; \
  UINT f_ec2; \
  SI f_eoffset8; \
  unsigned int length;
#define EXTRACT_IFMT_BRAEXT_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_3 = EXTRACT_MSB0_UINT (insn, 16, 4, 3); \
  f_ec2 = EXTRACT_MSB0_UINT (insn, 16, 7, 2); \
  f_eoffset8 = ((((EXTRACT_MSB0_INT (insn, 16, 9, 7)) << (1))) + (((pc) + (2)))); \

#define EXTRACT_IFMT_BRA_VARS \
  UINT f_op0_3; \
  UINT f_bmode; \
  UINT f_d; \
  SI f_eoffset11; \
  unsigned int length;
#define EXTRACT_IFMT_BRA_CODE \
  length = 2; \
  f_op0_3 = EXTRACT_MSB0_UINT (insn, 16, 0, 3); \
  f_bmode = EXTRACT_MSB0_UINT (insn, 16, 3, 2); \
  f_d = EXTRACT_MSB0_UINT (insn, 16, 5, 1); \
  f_eoffset11 = ((((EXTRACT_MSB0_INT (insn, 16, 6, 10)) << (1))) + (((pc) + (2)))); \

#define EXTRACT_IFMT_BNZD_VARS \
  UINT f_op1; \
  UINT f_op4_3; \
  USI f_H; \
  UINT f_op8_1; \
  SI f_eoffset8; \
  unsigned int length;
#define EXTRACT_IFMT_BNZD_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_3 = EXTRACT_MSB0_UINT (insn, 16, 4, 3); \
  f_H = ((EXTRACT_MSB0_UINT (insn, 16, 7, 1)) + (6)); \
  f_op8_1 = EXTRACT_MSB0_UINT (insn, 16, 8, 1); \
  f_eoffset8 = ((((EXTRACT_MSB0_INT (insn, 16, 9, 7)) << (1))) + (((pc) + (2)))); \

#define EXTRACT_IFMT_JPFAI_VARS \
  UINT f_op1; \
  UINT f_op2; \
  UINT f_op3; \
  UINT f_op12_1; \
  USI f_An1; \
  unsigned int length;
#define EXTRACT_IFMT_JPFAI_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op2 = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op3 = EXTRACT_MSB0_UINT (insn, 16, 8, 4); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 16, 12, 1); \
  f_An1 = ((EXTRACT_MSB0_UINT (insn, 16, 13, 3)) + (8)); \

#define EXTRACT_IFMT_JPFIMM22_VARS \
  UINT f_op1; \
  UINT f_op2; \
  UINT f_op8_1; \
  UINT f_op9_1; \
  UINT f_imm22; \
  unsigned int length;
#define EXTRACT_IFMT_JPFIMM22_CODE \
  length = 4; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 32, 0, 4); \
  f_op2 = EXTRACT_MSB0_UINT (insn, 32, 4, 4); \
  f_op8_1 = EXTRACT_MSB0_UINT (insn, 32, 8, 1); \
  f_op9_1 = EXTRACT_MSB0_UINT (insn, 32, 9, 1); \
  f_imm22 = EXTRACT_MSB0_UINT (insn, 32, 10, 22); \

#define EXTRACT_IFMT_JMPIMM22_VARS \
  UINT f_op1; \
  UINT f_op2; \
  UINT f_op8_2; \
  UINT f_imm22; \
  unsigned int length;
#define EXTRACT_IFMT_JMPIMM22_CODE \
  length = 4; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 32, 0, 4); \
  f_op2 = EXTRACT_MSB0_UINT (insn, 32, 4, 4); \
  f_op8_2 = EXTRACT_MSB0_UINT (insn, 32, 8, 2); \
  f_imm22 = EXTRACT_MSB0_UINT (insn, 32, 10, 22); \

#define EXTRACT_IFMT_BSRD_VARS \
  UINT f_op1; \
  SI f_eoffset13; \
  unsigned int length;
#define EXTRACT_IFMT_BSRD_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_eoffset13 = ((((EXTRACT_MSB0_INT (insn, 16, 4, 12)) << (1))) + (((pc) + (2)))); \

#define EXTRACT_IFMT_SWI_VARS \
  UINT f_op1; \
  UINT f_op2; \
  UINT f_op8_2; \
  UINT f_imm6; \
  unsigned int length;
#define EXTRACT_IFMT_SWI_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op2 = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op8_2 = EXTRACT_MSB0_UINT (insn, 16, 8, 2); \
  f_imm6 = EXTRACT_MSB0_UINT (insn, 16, 10, 6); \

#define EXTRACT_IFMT_CLDR_VARS \
  UINT f_op1; \
  UINT f_op4_3; \
  UINT f_imm5c; \
  UINT f_op12_1; \
  UINT f_Dn1; \
  unsigned int length;
#define EXTRACT_IFMT_CLDR_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_3 = EXTRACT_MSB0_UINT (insn, 16, 4, 3); \
  f_imm5c = EXTRACT_MSB0_UINT (insn, 16, 7, 5); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 16, 12, 1); \
  f_Dn1 = EXTRACT_MSB0_UINT (insn, 16, 13, 3); \

#define EXTRACT_IFMT_CLDW_VARS \
  UINT f_op1; \
  UINT f_op4_3; \
  UINT f_imm5c; \
  UINT f_op12_1; \
  UINT f_Dn1; \
  unsigned int length;
#define EXTRACT_IFMT_CLDW_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op4_3 = EXTRACT_MSB0_UINT (insn, 16, 4, 3); \
  f_imm5c = EXTRACT_MSB0_UINT (insn, 16, 7, 5); \
  f_op12_1 = EXTRACT_MSB0_UINT (insn, 16, 12, 1); \
  f_Dn1 = EXTRACT_MSB0_UINT (insn, 16, 13, 3); \

#define EXTRACT_IFMT_COP_VARS \
  UINT f_op0_3; \
  UINT f_imm13; \
  unsigned int length;
#define EXTRACT_IFMT_COP_CODE \
  length = 2; \
  f_op0_3 = EXTRACT_MSB0_UINT (insn, 16, 0, 3); \
  f_imm13 = EXTRACT_MSB0_UINT (insn, 16, 3, 13); \

#define EXTRACT_IFMT_SYS_VARS \
  UINT f_op1; \
  UINT f_op2; \
  UINT f_op8_3; \
  UINT f_imm5; \
  unsigned int length;
#define EXTRACT_IFMT_SYS_CODE \
  length = 2; \
  f_op1 = EXTRACT_MSB0_UINT (insn, 16, 0, 4); \
  f_op2 = EXTRACT_MSB0_UINT (insn, 16, 4, 4); \
  f_op8_3 = EXTRACT_MSB0_UINT (insn, 16, 8, 3); \
  f_imm5 = EXTRACT_MSB0_UINT (insn, 16, 11, 5); \

/* Collection of various things for the trace handler to use.  */

typedef struct trace_record {
  IADDR pc;
  /* FIXME:wip */
} TRACE_RECORD;

#endif /* CPU_CALMRISC16BF_H */
