/* Main header for the calmrisc16.  */

#define USING_SIM_BASE_H /* FIXME: quick hack */

struct _sim_cpu; /* FIXME: should be in sim-basics.h */
typedef struct _sim_cpu SIM_CPU;

/* sim-basics.h includes config.h but cgen-types.h must be included before
   sim-basics.h and cgen-types.h needs config.h.  */
#include "config.h"

#include "symcat.h"
#include "sim-basics.h"
#include "cgen-types.h"
#include "calmrisc16-desc.h"
#include "calmrisc16-opc.h"
#include "arch.h"

/* Pull in CALMRISC16_{DATA,INSN}_{MASK,VALUE}.  */
#include "elf/calmrisc16.h"

/* Convert between CPU-internal addresses and sim_core addresses.  */
#define CPU2DATA(addr) (CALMRISC16_DATA_VALUE + (addr))
#define DATA2CPU(addr) ((addr) - CALMRISC16_DATA_VALUE)
#define CPU2INSN(addr) (CALMRISC16_INSN_VALUE + (addr))
#define INSN2CPU(addr) ((addr) - CALMRISC16_INSN_VALUE)

/* These may seem overly complex, but they allow for arbitrary transformations
   within the mapping macros.  */
#define CALMRISC16_INSN_MEM_SIZE (CPU2INSN (0x400000) - CPU2INSN (0x0000))
#define CALMRISC16_DATA_MEM_SIZE (CPU2DATA (0x400000) - CPU2DATA (0x0000))

#undef MAX
#define MAX(a, b) ((a) > (b) ? (a) : (b))

/* Default memory size.  */
#define CALMRISC16_DEFAULT_MEM_SIZE \
  MAX (CPU2INSN (0x400000), CPU2DATA (0x400000))

/* These must be defined before sim-base.h.  */
typedef USI sim_cia;

#define CIA_GET(cpu)     CPU_PC_GET (cpu)
#define CIA_SET(cpu,val) CPU_PC_SET ((cpu), (val))

#include "sim-base.h"
#include "cgen-sim.h"
#include "calmrisc16-sim.h"

/* The _sim_cpu struct.  */

struct _sim_cpu {
  /* sim/common cpu base.  */
  sim_cpu_base base;

  /* Static parts of cgen.  */
  CGEN_CPU cgen_cpu;

  /* CPU specific parts go here.
     Note that in files that don't need to access these pieces WANT_CPU_FOO
     won't be defined and thus these parts won't appear.  This is ok in the
     sense that things work.  It is a source of bugs though.
     One has to of course be careful to not take the size of this
     struct and no structure members accessed in non-cpu specific files can
     go after here.  Oh for a better language.  */
#if defined (WANT_CPU_CALMRISC16BF)
  CALMRISC16BF_CPU_DATA cpu_data;
#endif
};

/* The sim_state struct.  */

struct sim_state {
  sim_cpu *cpu;
#define STATE_CPU(sd, n) (/*&*/ (sd)->cpu)

  CGEN_STATE cgen_state;

  sim_state_base base;
};

/* Misc.  */

/* Catch address exceptions.  */
extern SIM_CORE_SIGNAL_FN calmrisc16_core_signal;
#define SIM_CORE_SIGNAL(SD,CPU,CIA,MAP,NR_BYTES,ADDR,TRANSFER,ERROR) \
calmrisc16_core_signal ((SD), (CPU), (CIA), (MAP), (NR_BYTES), (ADDR), \
		  (TRANSFER), (ERROR))
